﻿using Microsoft.Owin.Security.OAuth;
using System.Web.Http;

namespace CloudReporting.MVC
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            // Web API configuration and services
            // Configure Web API to use only bearer token authentication.
            config.SuppressDefaultHostAuthentication();
            config.Filters.Add(new HostAuthenticationFilter(OAuthDefaults.AuthenticationType));

            // Web API routes
            config.MapHttpAttributeRoutes();

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{category}/{format}",
                defaults: new { category = RouteParameter.Optional,
                                format = RouteParameter.Optional }
            );
        }
    }
}
